Forward e-mail mail.message.forward

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: mail

Who can execute the method: a user with access to the mailbox where the e-mail is located

The mail.message.forward method forwards an e-mail.

Method Parameters

Required parameters are marked with *

Name
type

Description

forwardMessageId*
integer

Identifier of the e-mail to be forwarded.

The identifier can be obtained using the mail.message.list method.

from*
string

Sender's e-mail.

Available addresses can be obtained using the mail.mailbox.senders method.

to*
array

An array of recipient e-mail addresses

subject*
string

E-mail subject

body*
string

E-mail text: plain text or basic HTML

cc
array

An array of CC recipient e-mail addresses

bcc
array

An array of BCC recipient e-mail addresses

Code Examples

How to Use Examples in Documentation

The new API call differs by adding the /api/ parameter to the request:

https://{installation_address}/rest/api/{user_id}/{webhook_token}/mail.message.forward

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"forwardMessageId":15,"from":"user@example.com","to":["manager@example.com"],"subject":"Fwd: Contract","body":"Forwarding the email."}' \
        https://**put_your_bitrix24_address**/rest/api/**put_your_user_id_here**/**put_your_webhook_here**/mail.message.forward
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"forwardMessageId":15,"from":"user@example.com","to":["manager@example.com"],"subject":"Fwd: Contract","body":"Forwarding the email.","auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/api/mail.message.forward
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl, fetch.

try
        {
            const response = await $b24.callMethod(
                'mail.message.forward',
                {
                    forwardMessageId: 15,
                    from: 'user@example.com',
                    to: ['manager@example.com'],
                    subject: 'Fwd: Contract',
                    body: 'Forwarding the email.'
                }
            );
        
            const result = response.getData().result;
            console.log('Forward result:', result);
        }
        catch( error )
        {
            console.error('Error:', error);
        }
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl, fetch.

try {
            $response = $b24Service
                ->core
                ->call(
                    'mail.message.forward',
                    [
                        'forwardMessageId' => 15,
                        'from' => 'user@example.com',
                        'to' => ['manager@example.com'],
                        'subject' => 'Fwd: Contract',
                        'body' => 'Forwarding the email.'
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error: ' . $e->getMessage();
        }
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl, fetch.

BX24.callMethod(
            'mail.message.forward',
            {
                forwardMessageId: 15,
                from: 'user@example.com',
                to: ['manager@example.com'],
                subject: 'Fwd: Contract',
                body: 'Forwarding the email.'
            },
            function(result){
                console.info(result.data());
                console.log(result);
            }
        );
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl, fetch.

require_once('crest.php');
        
        $result = CRest::call(
            'mail.message.forward',
            [
                'forwardMessageId' => 15,
                'from' => 'user@example.com',
                'to' => ['manager@example.com'],
                'subject' => 'Fwd: Contract',
                'body' => 'Forwarding the email.'
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP status: 200

{
            "result": {
                "success": true,
                "to": [
                    "manager@example.com"
                ]
            },
            "time": {
                "start": 1779819678,
                "finish": 1779819678.84803,
                "duration": 0.8480300903320312,
                "processing": 0,
                "date_start": "2026-05-26T21:21:18+03:00",
                "date_finish": "2026-05-26T21:21:18+03:00",
                "operating_reset_at": 1779820278,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
object

Object with the sending result

success
boolean

Successful sending flag

to
array

Recipients to whom the e-mail was sent

time
time

Request execution time information

Error Handling

HTTP status: 400

{
            "error": {
                "code": "BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION",
                "message": "Error during request object validation",
                "validation": [
                    {
                        "message": "Mandatory field `forwardMessageId` is missing",
                        "field": "forwardMessageId"
                    }
                ]
            }
        }
        

Name
type

Description

error.code
string

String error code. Use it to identify the type of exception

error.message
string

Text description of the error

error.validation
array

Array with error details. Present only in data validation errors BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

error.validation[].field
string

Name of the field where the validation error occurred

error.validation[].message
string

Description of the error related to the specified field

Possible Error Codes

Request Validation Errors

Error code: BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

Field

Error description

How to fix

forwardMessageId

Mandatory field forwardMessageId is not specified

Pass forwardMessageId in the request body

from

Mandatory field from is not specified

Pass from in the request body

to

Mandatory field to is not specified

Pass to in the request body

subject

Mandatory field subject is not specified

Pass subject in the request body

body

Mandatory field body is not specified

Pass body in the request body

forwardMessageId

MESSAGE_FORWARD_FAILED

Check the existence of the e-mail and access to it, then retry the request

to

NO_RECIPIENTS

Check that the to array contains correct recipient addresses

to, cc, bcc

RESOLVE_RECIPIENTS_ERROR

Check the value format and recipient availability in to, cc, bcc

Access Errors

Error code: BITRIX_REST_V3_EXCEPTION_ACCESSDENIEDEXCEPTION

Field

Error description

How to fix

-

Access denied

Check user permissions and scope mail

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning